# Contributing to DollarBot

Follow the set of guidelines below to contribute to DollarBot!

## Code of Conduct

This project and everyone participating in it is governed by the [Code of Conduct](https://github.com/aditikilledar/dollar_bot_SE23/blob/main/CODE_OF_CONDUCT.md). By participating, you are expected to upload this code. Please report unacceptable behavior to akilled@ncsu.edu.

Note that this project is created as part of CSC 510 Coursework at NC State University for Fall'23.

Prerequistes required before starting this project:
- Working Python Knowledge
- Some knowledge of Telegram Bots

If you like our project and would like to contribue otherwise, please note:
Before creating a branch, reach out to the maintainers to confirm if the reposityory is still being actively maintained.

## How can I Contribute -

# Pull Request Process
1. Pass all the test cases that we have mentioned in the test.py.
2. Update the README.md with the changes you have made.
3. Add all the unnecessary build files have to the .gitignore file.
4. Mention any new installatiuon dependencies in the requirements.txt file.

# Committing Changes
1. You need to start an issue on the project kanban board.
2. You need to move this issue from to_do to in progress.
3. Create a new branch and clone the repository.
4. Change the branch of the code using git checkout.
5. Make the required changes and commit everything to the newly created branch.
6. Create a new pull request.
 
# Reporting Bugs 
This section gives detailed information on how to report bugs. Reporting a bug will help the community and maintainers of the repository. <br>
Before reporting any bug, make sure it is correct and you have all the details with you. Fot creating any bug report, please fill out [the required template](https://github.com/atom/.github/blob/master/.github/ISSUE_TEMPLATE/bug_report.md). This template will give us necessary information to help solve a bug faster.

## Before Submitting A Bug Report
The following is a list of items you need to check before submitting a bug report. <br>

Check out this [debugging guide](https://flight-manual.atom.io/hacking-atom/sections/debugging/), which helps you to find the cause of the problem and you may fix it by yourself manually. <br>
A cursory search is necessary to check if the reported bug is already mentioned before or not. You can add to the existing bug report if the issue is still open.


## To Submit A Good Bug Report
[GitHub issues](https://github.com/aditikilledar/dollar_bot_SE23/issues) You can track the bugs from this. For the repository that has bug, create an issue and fill out [this template](https://github.com/atom/.github/blob/master/.github/ISSUE_TEMPLATE/bug_report.md) or our in-repo template to give details of the bug.


* To identify the problem, give the issue a clear and informative term. <br>
* Describe in as much detail as possible to duplicate the problem. Explain the problem and explain about the exact command sused in the terminal which caus ethe bug to occur.
* To demonstrate the steps, give specific examples. Include links to files or GitHub projects, or copy/pasteable snippets, which you use in those examples. If you're providing snippets in the issue, use [Markdown code blocks](https://help.github.com/articles/markdown-basics/#multiple-lines).
* Specify what is the problem beavior and what you expected to see and why
* If possible, include screenshots and animated GIFs that clearly demonstrate the problem. [this tool](https://www.cockos.com/licecap/)- to record GIFs on macOS and Windows, and [this tool](https://github.com/colinkeenan/silentcast) or [this tool](https://github.com/GNOME/byzanz) on Linux.
* To include a crash report, add a stack trace from the operating system. For macOS, `Console.app` under "Diagnostic and usage information" > "User diagnostic reports" has crash report. Include the crash report in the issue in a [code block](https://help.github.com/articles/markdown-basics/#multiple-lines), a [file attachment](https://help.github.com/articles/file-attachments-on-issues-and-pull-requests/), or put it in a [gist](https://gist.github.com/) and provide link to that gist.

Provide more context by answering these questions: <br>
* If the problem started happening recently then try downloading the old version of the packages and the code.
* Include details about your configuration and environment.
* What is the name and version of the OS you're using?
* Are you running the project in a virtual environment?
* Which packages have installed in your system? You can get a list of packages installed by running 'apm list --installed'

# Suggesting Enhancements

Any suggesting enhancements like adding new features or imporving existing functionalities, etc can done by following the below guidelines. They help maintainers understand your improvement. <br>
[the template](https://github.com/atom/.github/blob/master/.github/ISSUE_TEMPLATE/feature_request.md)- this template is to be filled to add suggestions. These can include the steps that you imagine you would take if the feature you're requesting existed.

## Before Submitting An Enhancement Suggestion

Check out this [debugging guide](https://flight-manual.atom.io/hacking-atom/sections/debugging/), which helps you to find the cause of the problem and you may fix it by yourself manually. <br>
[cursory search](https://github.com/search?q=+is%3Aissue+user%3Aatom) A cursory search is necessary to check if the reported bug is already mentioned before or not. You can add to the existing bug report if the issue is still open.

## To Submit A Good Enhancement Suggestion

[GitHub issues](https://github.com/aditikilledar/dollar_bot_SE23/issues) You can track the bugs from this. For the repository that has bug, create an issue and fill out [the template](https://github.com/atom/.github/blob/master/.github/ISSUE_TEMPLATE/bug_report.md or our in-repo enhancement template to give details of the bug.

* To identify the problem, give the issue a clear and informative term. <br>
* Describe in as much detail as possible to duplicate the problem. Explain the problem and explain about the exact command sused in the terminal which caus ethe bug to occur.
* To demonstrate the steps, give specific examples. Include links to files or GitHub projects, or copy/pasteable snippets, which you use in those examples. If you're providing snippets in the issue, use [Markdown code blocks](https://help.github.com/articles/markdown-basics/#multiple-lines).
* Specify what is the problem beavior and what you expected to see and why
* If possible, include screenshots and animated GIFs that clearly demonstrate the problem. [this tool](https://www.cockos.com/licecap/)- to record GIFs on macOS and Windows, and [this tool](https://github.com/colinkeenan/silentcast) or [this tool](https://github.com/GNOME/byzanz) on Linux.
* To include a crash report, add a stack trace from the operating system. For macOS, `Console.app` under "Diagnostic and usage information" > "User diagnostic reports" has crash report. Include the crash report in the issue in a [code block](https://help.github.com/articles/markdown-basics/#multiple-lines), a [file attachment](https://help.github.com/articles/file-attachments-on-issues-and-pull-requests/), or put it in a [gist](https://gist.github.com/) and provide link to that gist.
* For performance or memory issues, include a [CPU profile capture](https://flight-manual.atom.io/hacking-atom/sections/debugging/#diagnose-runtime-performance) with your report.
